This is Perl 5.004 Patchlevel 2 compiled for MiNT.

It should actually be enough to run the self-explanatory shell
script "makeperl" in this directory to run the test suite, 
to install the binaries, manpages and eventually the documentation 
in html format.

If this doesn't work you have to run the corresponding perl scripts
"installperl", "installman" and "installhtml" by hand.  For the test
suite see the files in subdirectory "t".  The tests expect a working
perl to reside in directory "t".  Link/copy/move perl into that
directory to run the tests.  See harness.log for the results
for the harness test on my machine (and don't expect the tests
to run better on yours).

If the installation fails it is very likely that perl itself won't
run on your system (because the installation is done by perl scripts).
If you still want to have a try, you basically have to install the
contents of subdirectory "lib" as "/usr/local/lib/perl5", see 
"INSTALL" for details.  

Before installing you should have a brief look at "config.sh".  This
script will be evaluated during the installation process and you can
still set some installation parameters (of course it's of no use
to set compile-time options because this perl is already compiled).

Some hints when running perl on MiNT:

- If you follow the installation defaults, you don't have to set
  any perl-specific environment variables.  Remove everything that
  begins with "PERL..." from your environment.

- You should make absolutely sure that your environment variable
  UNIXMODE contains the letter b.  Otherwise you will get into
  trouble because files will be opened in stupid "text mode", i.e.
  linefeeds will be converted to carriage return/linefeed when 
  writing, and vice versa when reading.

- At least during the installation you should make sure that
  you have the environment variables LANG and LC_ALL unset.  The
  setlocale function in MiNTLib is broken and perl will produce
  warnings when running.

- Very important:  The "pwd" that comes with KGMD resp. KEMD
  is broken, it doesn't honor the "b" in UNIXMODE and unconditionally
  adds a carriage return to its output.  Use "pwd.safe" in this
  directory instead (the sources are included in hints/mint.sh).
  If you install via "makeperl" the script will automatically
  detect broken versions of pwd and will offer to install my
  version.

- If perl complains about certain files not found you've probably
  made an error during the installation.  Have a look at the compile
  time options I used either from within makeperl or by running
  
  	perl -V
  
  If perl wasn't successfully installed, you should run the perl
  in this directory and specify the include path:
  
  	./perl -V -I./lib
  
One annoying shortcoming of this version of perl5 is the lack of
syscall().  I think it won't be too difficult to write the missing
function but I didn't have the time to figure out how to integrate
it in a portable way into the perl source tree.  If somebody volunteers...
Feel free to do it!

If you wonder why I have included the directories "vms" and "plan9":
The pod files in there are required to install the html documentation.
BTW:  I couldn't test if building the html documentation works
because I ran out of disk space...  Anybody willing to send me a
2 GB scsi drive? ;-)

If you want to recompile perl yourself you will find the patches
I used for adapting perl5.004_02 to MiNT in "perl5.004_02mint.pat".
You should also copy hints/mint.sh to the same location in the source
tree.

Now try to run "makeperl" and you probably don't have to worry about
anything mentioned in this file.  It will check your system if it is 
fit for perl.  If you are short of memory you should expect some long 
tests (complex, recurse, ...) to fail; run them by hand to see if this 
is a really a problem.

Have fun with Perl!

Ciao

Guido
--
mailto:gufl0000@stud.uni-sb.de
http://stud.uni-sb.de/~gufl0000
